package com.habii.treasurehunt.framework.ui.editor;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagLayout;

import javax.swing.JPanel;

import com.habii.treasurehunt.framework.util.FormUtility;

public abstract class AbstractEditor extends JPanel{
	private static final long serialVersionUID = 838777207262673456L;
	
	protected JPanel form;
	protected FormUtility formUtility;
	
	public AbstractEditor(Dimension dimention) {
		setLayout(new BorderLayout());
		
		form = new JPanel(new GridBagLayout());
		formUtility = new FormUtility();
		
		add(form, BorderLayout.NORTH);
		setMinimumSize(dimention);
	}
	
	public abstract void update(Object actor);
}
