package com.habii.treasurehunt.framework.ui.map;

import java.awt.Color;
import javax.measure.unit.NonSI;
import com.habii.treasurehunt.treasurehunt.Post;

public class PostWayPoint extends BaseWaypoint{
	
	private Post post;

	public PostWayPoint(Post p){
		super(p.getPosition().latitudeValue(NonSI.DEGREE_ANGLE),p.getPosition().longitudeValue(NonSI.DEGREE_ANGLE));
		this.post = p;
	}

	public Color getColor(){
		return Color.BLACK;
	}

	public int getSize(){
		return 10;
	}

	public Post getPost() {
		return post;
	}
	
}

