package com.habii.treasurehunt.framework.ui;

import java.awt.CardLayout;

import javax.swing.JPanel;

public class CardPanel extends JPanel{
	private static final long serialVersionUID = 1L;
	
	public final static String POST = "Post Panel";
	public final static String PLAYER = "Player Panel";
	public final static String CONFIG = "Config Panel";

	public static final String EMPTY = "Empty";
	
	
    private String topPanel;
    
	public CardPanel() {
		super();
		setLayout(new CardLayout());
		topPanel = CardPanel.EMPTY;
	}

	public String getTopPanel() {
		return topPanel;
	}

	public void showConfigPanel() {
		CardLayout cl = (CardLayout)(this.getLayout());
        cl.show(this, CardPanel.CONFIG);
		topPanel = CardPanel.CONFIG;
	}
	
	public void showEmptyPanel() {
		CardLayout cl = (CardLayout)(this.getLayout());
        cl.show(this, CardPanel.EMPTY);
		topPanel = CardPanel.EMPTY;
	}
	
	public void showPlayerPanel() {
		CardLayout cl = (CardLayout)(this.getLayout());
        cl.show(this, CardPanel.PLAYER);
		topPanel = CardPanel.PLAYER;
	}
	public void showPostPanel() {
		CardLayout cl = (CardLayout)(this.getLayout());
        cl.show(this, CardPanel.POST);
        topPanel = CardPanel.POST;
	}
}