package com.habii.treasurehunt.framework.ui.map;

import java.awt.Color;

import javax.measure.unit.NonSI;

import com.habii.treasurehunt.framework.EnginePlayer;

public class PlayerWayPoint extends BaseWaypoint {

	private EnginePlayer player;

	public PlayerWayPoint(EnginePlayer player){
		super(player.getCurrentPosition().latitudeValue(NonSI.DEGREE_ANGLE),player.getCurrentPosition().longitudeValue(NonSI.DEGREE_ANGLE));
		this.player = player;
	}

	public Color getColor(){
		return Color.RED;
	}

	public int getSize(){
		return 10;
	}

	public EnginePlayer getPlayer() {
		return player;
	}
}
