package org.jscience.xtext.ui.contentassist.antlr.internal; 

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ui.editor.contentassist.antlr.internal.DFA;
import org.jscience.xtext.services.JscienceGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalJscienceParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_INT", "RULE_ID", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'\\u20AC'", "'$'", "'AllDatatypes'", "'{'", "'}'", "'eLatLong'", "'eMoney'", "'.'", "','"
    };
    public static final int RULE_ID=5;
    public static final int RULE_ANY_OTHER=10;
    public static final int EOF=-1;
    public static final int RULE_SL_COMMENT=8;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__19=19;
    public static final int RULE_STRING=6;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int RULE_INT=4;
    public static final int RULE_WS=9;

    // delegates
    // delegators


        public InternalJscienceParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalJscienceParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalJscienceParser.tokenNames; }
    public String getGrammarFileName() { return "../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g"; }


     
     	private JscienceGrammarAccess grammarAccess;
     	
        public void setGrammarAccess(JscienceGrammarAccess grammarAccess) {
        	this.grammarAccess = grammarAccess;
        }
        
        @Override
        protected Grammar getGrammar() {
        	return grammarAccess.getGrammar();
        }
        
        @Override
        protected String getValueForTokenName(String tokenName) {
        	return tokenName;
        }




    // $ANTLR start "entryRuleAllDatatypes"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:60:1: entryRuleAllDatatypes : ruleAllDatatypes EOF ;
    public final void entryRuleAllDatatypes() throws RecognitionException {
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:61:1: ( ruleAllDatatypes EOF )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:62:1: ruleAllDatatypes EOF
            {
             before(grammarAccess.getAllDatatypesRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleAllDatatypes_in_entryRuleAllDatatypes61);
            ruleAllDatatypes();

            state._fsp--;

             after(grammarAccess.getAllDatatypesRule()); 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleAllDatatypes68); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAllDatatypes"


    // $ANTLR start "ruleAllDatatypes"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:69:1: ruleAllDatatypes : ( ( rule__AllDatatypes__Group__0 ) ) ;
    public final void ruleAllDatatypes() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:73:2: ( ( ( rule__AllDatatypes__Group__0 ) ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:74:1: ( ( rule__AllDatatypes__Group__0 ) )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:74:1: ( ( rule__AllDatatypes__Group__0 ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:75:1: ( rule__AllDatatypes__Group__0 )
            {
             before(grammarAccess.getAllDatatypesAccess().getGroup()); 
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:76:1: ( rule__AllDatatypes__Group__0 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:76:2: rule__AllDatatypes__Group__0
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__0_in_ruleAllDatatypes94);
            rule__AllDatatypes__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAllDatatypesAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAllDatatypes"


    // $ANTLR start "entryRuleELatLong"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:88:1: entryRuleELatLong : ruleELatLong EOF ;
    public final void entryRuleELatLong() throws RecognitionException {
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:89:1: ( ruleELatLong EOF )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:90:1: ruleELatLong EOF
            {
             before(grammarAccess.getELatLongRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleELatLong_in_entryRuleELatLong121);
            ruleELatLong();

            state._fsp--;

             after(grammarAccess.getELatLongRule()); 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleELatLong128); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleELatLong"


    // $ANTLR start "ruleELatLong"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:97:1: ruleELatLong : ( ( rule__ELatLong__Group__0 ) ) ;
    public final void ruleELatLong() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:101:2: ( ( ( rule__ELatLong__Group__0 ) ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:102:1: ( ( rule__ELatLong__Group__0 ) )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:102:1: ( ( rule__ELatLong__Group__0 ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:103:1: ( rule__ELatLong__Group__0 )
            {
             before(grammarAccess.getELatLongAccess().getGroup()); 
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:104:1: ( rule__ELatLong__Group__0 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:104:2: rule__ELatLong__Group__0
            {
            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__0_in_ruleELatLong154);
            rule__ELatLong__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getELatLongAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleELatLong"


    // $ANTLR start "entryRuleEMoney"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:116:1: entryRuleEMoney : ruleEMoney EOF ;
    public final void entryRuleEMoney() throws RecognitionException {
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:117:1: ( ruleEMoney EOF )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:118:1: ruleEMoney EOF
            {
             before(grammarAccess.getEMoneyRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleEMoney_in_entryRuleEMoney181);
            ruleEMoney();

            state._fsp--;

             after(grammarAccess.getEMoneyRule()); 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleEMoney188); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleEMoney"


    // $ANTLR start "ruleEMoney"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:125:1: ruleEMoney : ( ( rule__EMoney__Group__0 ) ) ;
    public final void ruleEMoney() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:129:2: ( ( ( rule__EMoney__Group__0 ) ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:130:1: ( ( rule__EMoney__Group__0 ) )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:130:1: ( ( rule__EMoney__Group__0 ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:131:1: ( rule__EMoney__Group__0 )
            {
             before(grammarAccess.getEMoneyAccess().getGroup()); 
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:132:1: ( rule__EMoney__Group__0 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:132:2: rule__EMoney__Group__0
            {
            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group__0_in_ruleEMoney214);
            rule__EMoney__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getEMoneyAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleEMoney"


    // $ANTLR start "rule__EMoney__Alternatives_0"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:144:1: rule__EMoney__Alternatives_0 : ( ( '\\u20AC' ) | ( '$' ) );
    public final void rule__EMoney__Alternatives_0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:148:1: ( ( '\\u20AC' ) | ( '$' ) )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==11) ) {
                alt1=1;
            }
            else if ( (LA1_0==12) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:149:1: ( '\\u20AC' )
                    {
                    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:149:1: ( '\\u20AC' )
                    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:150:1: '\\u20AC'
                    {
                     before(grammarAccess.getEMoneyAccess().getEuroSignKeyword_0_0()); 
                    match(input,11,FollowSets000.FOLLOW_11_in_rule__EMoney__Alternatives_0251); 
                     after(grammarAccess.getEMoneyAccess().getEuroSignKeyword_0_0()); 

                    }


                    }
                    break;
                case 2 :
                    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:157:6: ( '$' )
                    {
                    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:157:6: ( '$' )
                    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:158:1: '$'
                    {
                     before(grammarAccess.getEMoneyAccess().getDollarSignKeyword_0_1()); 
                    match(input,12,FollowSets000.FOLLOW_12_in_rule__EMoney__Alternatives_0271); 
                     after(grammarAccess.getEMoneyAccess().getDollarSignKeyword_0_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Alternatives_0"


    // $ANTLR start "rule__AllDatatypes__Group__0"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:172:1: rule__AllDatatypes__Group__0 : rule__AllDatatypes__Group__0__Impl rule__AllDatatypes__Group__1 ;
    public final void rule__AllDatatypes__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:176:1: ( rule__AllDatatypes__Group__0__Impl rule__AllDatatypes__Group__1 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:177:2: rule__AllDatatypes__Group__0__Impl rule__AllDatatypes__Group__1
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__0__Impl_in_rule__AllDatatypes__Group__0303);
            rule__AllDatatypes__Group__0__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__1_in_rule__AllDatatypes__Group__0306);
            rule__AllDatatypes__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__0"


    // $ANTLR start "rule__AllDatatypes__Group__0__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:184:1: rule__AllDatatypes__Group__0__Impl : ( 'AllDatatypes' ) ;
    public final void rule__AllDatatypes__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:188:1: ( ( 'AllDatatypes' ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:189:1: ( 'AllDatatypes' )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:189:1: ( 'AllDatatypes' )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:190:1: 'AllDatatypes'
            {
             before(grammarAccess.getAllDatatypesAccess().getAllDatatypesKeyword_0()); 
            match(input,13,FollowSets000.FOLLOW_13_in_rule__AllDatatypes__Group__0__Impl334); 
             after(grammarAccess.getAllDatatypesAccess().getAllDatatypesKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__0__Impl"


    // $ANTLR start "rule__AllDatatypes__Group__1"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:203:1: rule__AllDatatypes__Group__1 : rule__AllDatatypes__Group__1__Impl rule__AllDatatypes__Group__2 ;
    public final void rule__AllDatatypes__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:207:1: ( rule__AllDatatypes__Group__1__Impl rule__AllDatatypes__Group__2 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:208:2: rule__AllDatatypes__Group__1__Impl rule__AllDatatypes__Group__2
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__1__Impl_in_rule__AllDatatypes__Group__1365);
            rule__AllDatatypes__Group__1__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__2_in_rule__AllDatatypes__Group__1368);
            rule__AllDatatypes__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__1"


    // $ANTLR start "rule__AllDatatypes__Group__1__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:215:1: rule__AllDatatypes__Group__1__Impl : ( '{' ) ;
    public final void rule__AllDatatypes__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:219:1: ( ( '{' ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:220:1: ( '{' )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:220:1: ( '{' )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:221:1: '{'
            {
             before(grammarAccess.getAllDatatypesAccess().getLeftCurlyBracketKeyword_1()); 
            match(input,14,FollowSets000.FOLLOW_14_in_rule__AllDatatypes__Group__1__Impl396); 
             after(grammarAccess.getAllDatatypesAccess().getLeftCurlyBracketKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__1__Impl"


    // $ANTLR start "rule__AllDatatypes__Group__2"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:234:1: rule__AllDatatypes__Group__2 : rule__AllDatatypes__Group__2__Impl rule__AllDatatypes__Group__3 ;
    public final void rule__AllDatatypes__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:238:1: ( rule__AllDatatypes__Group__2__Impl rule__AllDatatypes__Group__3 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:239:2: rule__AllDatatypes__Group__2__Impl rule__AllDatatypes__Group__3
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__2__Impl_in_rule__AllDatatypes__Group__2427);
            rule__AllDatatypes__Group__2__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__3_in_rule__AllDatatypes__Group__2430);
            rule__AllDatatypes__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__2"


    // $ANTLR start "rule__AllDatatypes__Group__2__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:246:1: rule__AllDatatypes__Group__2__Impl : ( ( rule__AllDatatypes__Group_2__0 ) ) ;
    public final void rule__AllDatatypes__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:250:1: ( ( ( rule__AllDatatypes__Group_2__0 ) ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:251:1: ( ( rule__AllDatatypes__Group_2__0 ) )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:251:1: ( ( rule__AllDatatypes__Group_2__0 ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:252:1: ( rule__AllDatatypes__Group_2__0 )
            {
             before(grammarAccess.getAllDatatypesAccess().getGroup_2()); 
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:253:1: ( rule__AllDatatypes__Group_2__0 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:253:2: rule__AllDatatypes__Group_2__0
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group_2__0_in_rule__AllDatatypes__Group__2__Impl457);
            rule__AllDatatypes__Group_2__0();

            state._fsp--;


            }

             after(grammarAccess.getAllDatatypesAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__2__Impl"


    // $ANTLR start "rule__AllDatatypes__Group__3"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:263:1: rule__AllDatatypes__Group__3 : rule__AllDatatypes__Group__3__Impl rule__AllDatatypes__Group__4 ;
    public final void rule__AllDatatypes__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:267:1: ( rule__AllDatatypes__Group__3__Impl rule__AllDatatypes__Group__4 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:268:2: rule__AllDatatypes__Group__3__Impl rule__AllDatatypes__Group__4
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__3__Impl_in_rule__AllDatatypes__Group__3487);
            rule__AllDatatypes__Group__3__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__4_in_rule__AllDatatypes__Group__3490);
            rule__AllDatatypes__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__3"


    // $ANTLR start "rule__AllDatatypes__Group__3__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:275:1: rule__AllDatatypes__Group__3__Impl : ( ( rule__AllDatatypes__Group_3__0 ) ) ;
    public final void rule__AllDatatypes__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:279:1: ( ( ( rule__AllDatatypes__Group_3__0 ) ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:280:1: ( ( rule__AllDatatypes__Group_3__0 ) )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:280:1: ( ( rule__AllDatatypes__Group_3__0 ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:281:1: ( rule__AllDatatypes__Group_3__0 )
            {
             before(grammarAccess.getAllDatatypesAccess().getGroup_3()); 
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:282:1: ( rule__AllDatatypes__Group_3__0 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:282:2: rule__AllDatatypes__Group_3__0
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group_3__0_in_rule__AllDatatypes__Group__3__Impl517);
            rule__AllDatatypes__Group_3__0();

            state._fsp--;


            }

             after(grammarAccess.getAllDatatypesAccess().getGroup_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__3__Impl"


    // $ANTLR start "rule__AllDatatypes__Group__4"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:292:1: rule__AllDatatypes__Group__4 : rule__AllDatatypes__Group__4__Impl ;
    public final void rule__AllDatatypes__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:296:1: ( rule__AllDatatypes__Group__4__Impl )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:297:2: rule__AllDatatypes__Group__4__Impl
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group__4__Impl_in_rule__AllDatatypes__Group__4547);
            rule__AllDatatypes__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__4"


    // $ANTLR start "rule__AllDatatypes__Group__4__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:303:1: rule__AllDatatypes__Group__4__Impl : ( '}' ) ;
    public final void rule__AllDatatypes__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:307:1: ( ( '}' ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:308:1: ( '}' )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:308:1: ( '}' )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:309:1: '}'
            {
             before(grammarAccess.getAllDatatypesAccess().getRightCurlyBracketKeyword_4()); 
            match(input,15,FollowSets000.FOLLOW_15_in_rule__AllDatatypes__Group__4__Impl575); 
             after(grammarAccess.getAllDatatypesAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group__4__Impl"


    // $ANTLR start "rule__AllDatatypes__Group_2__0"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:332:1: rule__AllDatatypes__Group_2__0 : rule__AllDatatypes__Group_2__0__Impl rule__AllDatatypes__Group_2__1 ;
    public final void rule__AllDatatypes__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:336:1: ( rule__AllDatatypes__Group_2__0__Impl rule__AllDatatypes__Group_2__1 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:337:2: rule__AllDatatypes__Group_2__0__Impl rule__AllDatatypes__Group_2__1
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group_2__0__Impl_in_rule__AllDatatypes__Group_2__0616);
            rule__AllDatatypes__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group_2__1_in_rule__AllDatatypes__Group_2__0619);
            rule__AllDatatypes__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group_2__0"


    // $ANTLR start "rule__AllDatatypes__Group_2__0__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:344:1: rule__AllDatatypes__Group_2__0__Impl : ( 'eLatLong' ) ;
    public final void rule__AllDatatypes__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:348:1: ( ( 'eLatLong' ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:349:1: ( 'eLatLong' )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:349:1: ( 'eLatLong' )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:350:1: 'eLatLong'
            {
             before(grammarAccess.getAllDatatypesAccess().getELatLongKeyword_2_0()); 
            match(input,16,FollowSets000.FOLLOW_16_in_rule__AllDatatypes__Group_2__0__Impl647); 
             after(grammarAccess.getAllDatatypesAccess().getELatLongKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group_2__0__Impl"


    // $ANTLR start "rule__AllDatatypes__Group_2__1"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:363:1: rule__AllDatatypes__Group_2__1 : rule__AllDatatypes__Group_2__1__Impl ;
    public final void rule__AllDatatypes__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:367:1: ( rule__AllDatatypes__Group_2__1__Impl )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:368:2: rule__AllDatatypes__Group_2__1__Impl
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group_2__1__Impl_in_rule__AllDatatypes__Group_2__1678);
            rule__AllDatatypes__Group_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group_2__1"


    // $ANTLR start "rule__AllDatatypes__Group_2__1__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:374:1: rule__AllDatatypes__Group_2__1__Impl : ( ( rule__AllDatatypes__ELatLongAssignment_2_1 ) ) ;
    public final void rule__AllDatatypes__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:378:1: ( ( ( rule__AllDatatypes__ELatLongAssignment_2_1 ) ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:379:1: ( ( rule__AllDatatypes__ELatLongAssignment_2_1 ) )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:379:1: ( ( rule__AllDatatypes__ELatLongAssignment_2_1 ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:380:1: ( rule__AllDatatypes__ELatLongAssignment_2_1 )
            {
             before(grammarAccess.getAllDatatypesAccess().getELatLongAssignment_2_1()); 
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:381:1: ( rule__AllDatatypes__ELatLongAssignment_2_1 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:381:2: rule__AllDatatypes__ELatLongAssignment_2_1
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__ELatLongAssignment_2_1_in_rule__AllDatatypes__Group_2__1__Impl705);
            rule__AllDatatypes__ELatLongAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getAllDatatypesAccess().getELatLongAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group_2__1__Impl"


    // $ANTLR start "rule__AllDatatypes__Group_3__0"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:395:1: rule__AllDatatypes__Group_3__0 : rule__AllDatatypes__Group_3__0__Impl rule__AllDatatypes__Group_3__1 ;
    public final void rule__AllDatatypes__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:399:1: ( rule__AllDatatypes__Group_3__0__Impl rule__AllDatatypes__Group_3__1 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:400:2: rule__AllDatatypes__Group_3__0__Impl rule__AllDatatypes__Group_3__1
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group_3__0__Impl_in_rule__AllDatatypes__Group_3__0739);
            rule__AllDatatypes__Group_3__0__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group_3__1_in_rule__AllDatatypes__Group_3__0742);
            rule__AllDatatypes__Group_3__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group_3__0"


    // $ANTLR start "rule__AllDatatypes__Group_3__0__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:407:1: rule__AllDatatypes__Group_3__0__Impl : ( 'eMoney' ) ;
    public final void rule__AllDatatypes__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:411:1: ( ( 'eMoney' ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:412:1: ( 'eMoney' )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:412:1: ( 'eMoney' )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:413:1: 'eMoney'
            {
             before(grammarAccess.getAllDatatypesAccess().getEMoneyKeyword_3_0()); 
            match(input,17,FollowSets000.FOLLOW_17_in_rule__AllDatatypes__Group_3__0__Impl770); 
             after(grammarAccess.getAllDatatypesAccess().getEMoneyKeyword_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group_3__0__Impl"


    // $ANTLR start "rule__AllDatatypes__Group_3__1"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:426:1: rule__AllDatatypes__Group_3__1 : rule__AllDatatypes__Group_3__1__Impl ;
    public final void rule__AllDatatypes__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:430:1: ( rule__AllDatatypes__Group_3__1__Impl )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:431:2: rule__AllDatatypes__Group_3__1__Impl
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__Group_3__1__Impl_in_rule__AllDatatypes__Group_3__1801);
            rule__AllDatatypes__Group_3__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group_3__1"


    // $ANTLR start "rule__AllDatatypes__Group_3__1__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:437:1: rule__AllDatatypes__Group_3__1__Impl : ( ( rule__AllDatatypes__EMoneyAssignment_3_1 ) ) ;
    public final void rule__AllDatatypes__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:441:1: ( ( ( rule__AllDatatypes__EMoneyAssignment_3_1 ) ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:442:1: ( ( rule__AllDatatypes__EMoneyAssignment_3_1 ) )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:442:1: ( ( rule__AllDatatypes__EMoneyAssignment_3_1 ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:443:1: ( rule__AllDatatypes__EMoneyAssignment_3_1 )
            {
             before(grammarAccess.getAllDatatypesAccess().getEMoneyAssignment_3_1()); 
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:444:1: ( rule__AllDatatypes__EMoneyAssignment_3_1 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:444:2: rule__AllDatatypes__EMoneyAssignment_3_1
            {
            pushFollow(FollowSets000.FOLLOW_rule__AllDatatypes__EMoneyAssignment_3_1_in_rule__AllDatatypes__Group_3__1__Impl828);
            rule__AllDatatypes__EMoneyAssignment_3_1();

            state._fsp--;


            }

             after(grammarAccess.getAllDatatypesAccess().getEMoneyAssignment_3_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__Group_3__1__Impl"


    // $ANTLR start "rule__ELatLong__Group__0"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:458:1: rule__ELatLong__Group__0 : rule__ELatLong__Group__0__Impl rule__ELatLong__Group__1 ;
    public final void rule__ELatLong__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:462:1: ( rule__ELatLong__Group__0__Impl rule__ELatLong__Group__1 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:463:2: rule__ELatLong__Group__0__Impl rule__ELatLong__Group__1
            {
            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__0__Impl_in_rule__ELatLong__Group__0862);
            rule__ELatLong__Group__0__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__1_in_rule__ELatLong__Group__0865);
            rule__ELatLong__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__0"


    // $ANTLR start "rule__ELatLong__Group__0__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:470:1: rule__ELatLong__Group__0__Impl : ( RULE_INT ) ;
    public final void rule__ELatLong__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:474:1: ( ( RULE_INT ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:475:1: ( RULE_INT )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:475:1: ( RULE_INT )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:476:1: RULE_INT
            {
             before(grammarAccess.getELatLongAccess().getINTTerminalRuleCall_0()); 
            match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_rule__ELatLong__Group__0__Impl892); 
             after(grammarAccess.getELatLongAccess().getINTTerminalRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__0__Impl"


    // $ANTLR start "rule__ELatLong__Group__1"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:487:1: rule__ELatLong__Group__1 : rule__ELatLong__Group__1__Impl rule__ELatLong__Group__2 ;
    public final void rule__ELatLong__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:491:1: ( rule__ELatLong__Group__1__Impl rule__ELatLong__Group__2 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:492:2: rule__ELatLong__Group__1__Impl rule__ELatLong__Group__2
            {
            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__1__Impl_in_rule__ELatLong__Group__1921);
            rule__ELatLong__Group__1__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__2_in_rule__ELatLong__Group__1924);
            rule__ELatLong__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__1"


    // $ANTLR start "rule__ELatLong__Group__1__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:499:1: rule__ELatLong__Group__1__Impl : ( '.' ) ;
    public final void rule__ELatLong__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:503:1: ( ( '.' ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:504:1: ( '.' )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:504:1: ( '.' )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:505:1: '.'
            {
             before(grammarAccess.getELatLongAccess().getFullStopKeyword_1()); 
            match(input,18,FollowSets000.FOLLOW_18_in_rule__ELatLong__Group__1__Impl952); 
             after(grammarAccess.getELatLongAccess().getFullStopKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__1__Impl"


    // $ANTLR start "rule__ELatLong__Group__2"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:518:1: rule__ELatLong__Group__2 : rule__ELatLong__Group__2__Impl rule__ELatLong__Group__3 ;
    public final void rule__ELatLong__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:522:1: ( rule__ELatLong__Group__2__Impl rule__ELatLong__Group__3 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:523:2: rule__ELatLong__Group__2__Impl rule__ELatLong__Group__3
            {
            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__2__Impl_in_rule__ELatLong__Group__2983);
            rule__ELatLong__Group__2__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__3_in_rule__ELatLong__Group__2986);
            rule__ELatLong__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__2"


    // $ANTLR start "rule__ELatLong__Group__2__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:530:1: rule__ELatLong__Group__2__Impl : ( RULE_INT ) ;
    public final void rule__ELatLong__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:534:1: ( ( RULE_INT ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:535:1: ( RULE_INT )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:535:1: ( RULE_INT )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:536:1: RULE_INT
            {
             before(grammarAccess.getELatLongAccess().getINTTerminalRuleCall_2()); 
            match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_rule__ELatLong__Group__2__Impl1013); 
             after(grammarAccess.getELatLongAccess().getINTTerminalRuleCall_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__2__Impl"


    // $ANTLR start "rule__ELatLong__Group__3"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:547:1: rule__ELatLong__Group__3 : rule__ELatLong__Group__3__Impl rule__ELatLong__Group__4 ;
    public final void rule__ELatLong__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:551:1: ( rule__ELatLong__Group__3__Impl rule__ELatLong__Group__4 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:552:2: rule__ELatLong__Group__3__Impl rule__ELatLong__Group__4
            {
            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__3__Impl_in_rule__ELatLong__Group__31042);
            rule__ELatLong__Group__3__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__4_in_rule__ELatLong__Group__31045);
            rule__ELatLong__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__3"


    // $ANTLR start "rule__ELatLong__Group__3__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:559:1: rule__ELatLong__Group__3__Impl : ( ',' ) ;
    public final void rule__ELatLong__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:563:1: ( ( ',' ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:564:1: ( ',' )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:564:1: ( ',' )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:565:1: ','
            {
             before(grammarAccess.getELatLongAccess().getCommaKeyword_3()); 
            match(input,19,FollowSets000.FOLLOW_19_in_rule__ELatLong__Group__3__Impl1073); 
             after(grammarAccess.getELatLongAccess().getCommaKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__3__Impl"


    // $ANTLR start "rule__ELatLong__Group__4"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:578:1: rule__ELatLong__Group__4 : rule__ELatLong__Group__4__Impl rule__ELatLong__Group__5 ;
    public final void rule__ELatLong__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:582:1: ( rule__ELatLong__Group__4__Impl rule__ELatLong__Group__5 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:583:2: rule__ELatLong__Group__4__Impl rule__ELatLong__Group__5
            {
            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__4__Impl_in_rule__ELatLong__Group__41104);
            rule__ELatLong__Group__4__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__5_in_rule__ELatLong__Group__41107);
            rule__ELatLong__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__4"


    // $ANTLR start "rule__ELatLong__Group__4__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:590:1: rule__ELatLong__Group__4__Impl : ( RULE_INT ) ;
    public final void rule__ELatLong__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:594:1: ( ( RULE_INT ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:595:1: ( RULE_INT )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:595:1: ( RULE_INT )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:596:1: RULE_INT
            {
             before(grammarAccess.getELatLongAccess().getINTTerminalRuleCall_4()); 
            match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_rule__ELatLong__Group__4__Impl1134); 
             after(grammarAccess.getELatLongAccess().getINTTerminalRuleCall_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__4__Impl"


    // $ANTLR start "rule__ELatLong__Group__5"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:607:1: rule__ELatLong__Group__5 : rule__ELatLong__Group__5__Impl rule__ELatLong__Group__6 ;
    public final void rule__ELatLong__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:611:1: ( rule__ELatLong__Group__5__Impl rule__ELatLong__Group__6 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:612:2: rule__ELatLong__Group__5__Impl rule__ELatLong__Group__6
            {
            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__5__Impl_in_rule__ELatLong__Group__51163);
            rule__ELatLong__Group__5__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__6_in_rule__ELatLong__Group__51166);
            rule__ELatLong__Group__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__5"


    // $ANTLR start "rule__ELatLong__Group__5__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:619:1: rule__ELatLong__Group__5__Impl : ( '.' ) ;
    public final void rule__ELatLong__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:623:1: ( ( '.' ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:624:1: ( '.' )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:624:1: ( '.' )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:625:1: '.'
            {
             before(grammarAccess.getELatLongAccess().getFullStopKeyword_5()); 
            match(input,18,FollowSets000.FOLLOW_18_in_rule__ELatLong__Group__5__Impl1194); 
             after(grammarAccess.getELatLongAccess().getFullStopKeyword_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__5__Impl"


    // $ANTLR start "rule__ELatLong__Group__6"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:638:1: rule__ELatLong__Group__6 : rule__ELatLong__Group__6__Impl ;
    public final void rule__ELatLong__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:642:1: ( rule__ELatLong__Group__6__Impl )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:643:2: rule__ELatLong__Group__6__Impl
            {
            pushFollow(FollowSets000.FOLLOW_rule__ELatLong__Group__6__Impl_in_rule__ELatLong__Group__61225);
            rule__ELatLong__Group__6__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__6"


    // $ANTLR start "rule__ELatLong__Group__6__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:649:1: rule__ELatLong__Group__6__Impl : ( RULE_INT ) ;
    public final void rule__ELatLong__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:653:1: ( ( RULE_INT ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:654:1: ( RULE_INT )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:654:1: ( RULE_INT )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:655:1: RULE_INT
            {
             before(grammarAccess.getELatLongAccess().getINTTerminalRuleCall_6()); 
            match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_rule__ELatLong__Group__6__Impl1252); 
             after(grammarAccess.getELatLongAccess().getINTTerminalRuleCall_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ELatLong__Group__6__Impl"


    // $ANTLR start "rule__EMoney__Group__0"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:680:1: rule__EMoney__Group__0 : rule__EMoney__Group__0__Impl rule__EMoney__Group__1 ;
    public final void rule__EMoney__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:684:1: ( rule__EMoney__Group__0__Impl rule__EMoney__Group__1 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:685:2: rule__EMoney__Group__0__Impl rule__EMoney__Group__1
            {
            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group__0__Impl_in_rule__EMoney__Group__01295);
            rule__EMoney__Group__0__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group__1_in_rule__EMoney__Group__01298);
            rule__EMoney__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group__0"


    // $ANTLR start "rule__EMoney__Group__0__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:692:1: rule__EMoney__Group__0__Impl : ( ( rule__EMoney__Alternatives_0 ) ) ;
    public final void rule__EMoney__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:696:1: ( ( ( rule__EMoney__Alternatives_0 ) ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:697:1: ( ( rule__EMoney__Alternatives_0 ) )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:697:1: ( ( rule__EMoney__Alternatives_0 ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:698:1: ( rule__EMoney__Alternatives_0 )
            {
             before(grammarAccess.getEMoneyAccess().getAlternatives_0()); 
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:699:1: ( rule__EMoney__Alternatives_0 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:699:2: rule__EMoney__Alternatives_0
            {
            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Alternatives_0_in_rule__EMoney__Group__0__Impl1325);
            rule__EMoney__Alternatives_0();

            state._fsp--;


            }

             after(grammarAccess.getEMoneyAccess().getAlternatives_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group__0__Impl"


    // $ANTLR start "rule__EMoney__Group__1"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:709:1: rule__EMoney__Group__1 : rule__EMoney__Group__1__Impl rule__EMoney__Group__2 ;
    public final void rule__EMoney__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:713:1: ( rule__EMoney__Group__1__Impl rule__EMoney__Group__2 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:714:2: rule__EMoney__Group__1__Impl rule__EMoney__Group__2
            {
            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group__1__Impl_in_rule__EMoney__Group__11355);
            rule__EMoney__Group__1__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group__2_in_rule__EMoney__Group__11358);
            rule__EMoney__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group__1"


    // $ANTLR start "rule__EMoney__Group__1__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:721:1: rule__EMoney__Group__1__Impl : ( RULE_INT ) ;
    public final void rule__EMoney__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:725:1: ( ( RULE_INT ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:726:1: ( RULE_INT )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:726:1: ( RULE_INT )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:727:1: RULE_INT
            {
             before(grammarAccess.getEMoneyAccess().getINTTerminalRuleCall_1()); 
            match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_rule__EMoney__Group__1__Impl1385); 
             after(grammarAccess.getEMoneyAccess().getINTTerminalRuleCall_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group__1__Impl"


    // $ANTLR start "rule__EMoney__Group__2"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:738:1: rule__EMoney__Group__2 : rule__EMoney__Group__2__Impl ;
    public final void rule__EMoney__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:742:1: ( rule__EMoney__Group__2__Impl )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:743:2: rule__EMoney__Group__2__Impl
            {
            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group__2__Impl_in_rule__EMoney__Group__21414);
            rule__EMoney__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group__2"


    // $ANTLR start "rule__EMoney__Group__2__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:749:1: rule__EMoney__Group__2__Impl : ( ( rule__EMoney__Group_2__0 ) ) ;
    public final void rule__EMoney__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:753:1: ( ( ( rule__EMoney__Group_2__0 ) ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:754:1: ( ( rule__EMoney__Group_2__0 ) )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:754:1: ( ( rule__EMoney__Group_2__0 ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:755:1: ( rule__EMoney__Group_2__0 )
            {
             before(grammarAccess.getEMoneyAccess().getGroup_2()); 
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:756:1: ( rule__EMoney__Group_2__0 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:756:2: rule__EMoney__Group_2__0
            {
            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group_2__0_in_rule__EMoney__Group__2__Impl1441);
            rule__EMoney__Group_2__0();

            state._fsp--;


            }

             after(grammarAccess.getEMoneyAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group__2__Impl"


    // $ANTLR start "rule__EMoney__Group_2__0"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:772:1: rule__EMoney__Group_2__0 : rule__EMoney__Group_2__0__Impl rule__EMoney__Group_2__1 ;
    public final void rule__EMoney__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:776:1: ( rule__EMoney__Group_2__0__Impl rule__EMoney__Group_2__1 )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:777:2: rule__EMoney__Group_2__0__Impl rule__EMoney__Group_2__1
            {
            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group_2__0__Impl_in_rule__EMoney__Group_2__01477);
            rule__EMoney__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group_2__1_in_rule__EMoney__Group_2__01480);
            rule__EMoney__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group_2__0"


    // $ANTLR start "rule__EMoney__Group_2__0__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:784:1: rule__EMoney__Group_2__0__Impl : ( '.' ) ;
    public final void rule__EMoney__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:788:1: ( ( '.' ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:789:1: ( '.' )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:789:1: ( '.' )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:790:1: '.'
            {
             before(grammarAccess.getEMoneyAccess().getFullStopKeyword_2_0()); 
            match(input,18,FollowSets000.FOLLOW_18_in_rule__EMoney__Group_2__0__Impl1508); 
             after(grammarAccess.getEMoneyAccess().getFullStopKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group_2__0__Impl"


    // $ANTLR start "rule__EMoney__Group_2__1"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:803:1: rule__EMoney__Group_2__1 : rule__EMoney__Group_2__1__Impl ;
    public final void rule__EMoney__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:807:1: ( rule__EMoney__Group_2__1__Impl )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:808:2: rule__EMoney__Group_2__1__Impl
            {
            pushFollow(FollowSets000.FOLLOW_rule__EMoney__Group_2__1__Impl_in_rule__EMoney__Group_2__11539);
            rule__EMoney__Group_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group_2__1"


    // $ANTLR start "rule__EMoney__Group_2__1__Impl"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:814:1: rule__EMoney__Group_2__1__Impl : ( RULE_INT ) ;
    public final void rule__EMoney__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:818:1: ( ( RULE_INT ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:819:1: ( RULE_INT )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:819:1: ( RULE_INT )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:820:1: RULE_INT
            {
             before(grammarAccess.getEMoneyAccess().getINTTerminalRuleCall_2_1()); 
            match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_rule__EMoney__Group_2__1__Impl1566); 
             after(grammarAccess.getEMoneyAccess().getINTTerminalRuleCall_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__EMoney__Group_2__1__Impl"


    // $ANTLR start "rule__AllDatatypes__ELatLongAssignment_2_1"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:836:1: rule__AllDatatypes__ELatLongAssignment_2_1 : ( ruleELatLong ) ;
    public final void rule__AllDatatypes__ELatLongAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:840:1: ( ( ruleELatLong ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:841:1: ( ruleELatLong )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:841:1: ( ruleELatLong )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:842:1: ruleELatLong
            {
             before(grammarAccess.getAllDatatypesAccess().getELatLongELatLongParserRuleCall_2_1_0()); 
            pushFollow(FollowSets000.FOLLOW_ruleELatLong_in_rule__AllDatatypes__ELatLongAssignment_2_11604);
            ruleELatLong();

            state._fsp--;

             after(grammarAccess.getAllDatatypesAccess().getELatLongELatLongParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__ELatLongAssignment_2_1"


    // $ANTLR start "rule__AllDatatypes__EMoneyAssignment_3_1"
    // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:851:1: rule__AllDatatypes__EMoneyAssignment_3_1 : ( ruleEMoney ) ;
    public final void rule__AllDatatypes__EMoneyAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
            
        try {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:855:1: ( ( ruleEMoney ) )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:856:1: ( ruleEMoney )
            {
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:856:1: ( ruleEMoney )
            // ../org.jscience.xtext.ui/src-gen/org/jscience/xtext/ui/contentassist/antlr/internal/InternalJscience.g:857:1: ruleEMoney
            {
             before(grammarAccess.getAllDatatypesAccess().getEMoneyEMoneyParserRuleCall_3_1_0()); 
            pushFollow(FollowSets000.FOLLOW_ruleEMoney_in_rule__AllDatatypes__EMoneyAssignment_3_11635);
            ruleEMoney();

            state._fsp--;

             after(grammarAccess.getAllDatatypesAccess().getEMoneyEMoneyParserRuleCall_3_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AllDatatypes__EMoneyAssignment_3_1"

    // Delegated rules


 

    
    private static class FollowSets000 {
        public static final BitSet FOLLOW_ruleAllDatatypes_in_entryRuleAllDatatypes61 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleAllDatatypes68 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__0_in_ruleAllDatatypes94 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleELatLong_in_entryRuleELatLong121 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleELatLong128 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__0_in_ruleELatLong154 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleEMoney_in_entryRuleEMoney181 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleEMoney188 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__EMoney__Group__0_in_ruleEMoney214 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_11_in_rule__EMoney__Alternatives_0251 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_12_in_rule__EMoney__Alternatives_0271 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__0__Impl_in_rule__AllDatatypes__Group__0303 = new BitSet(new long[]{0x0000000000004000L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__1_in_rule__AllDatatypes__Group__0306 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_13_in_rule__AllDatatypes__Group__0__Impl334 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__1__Impl_in_rule__AllDatatypes__Group__1365 = new BitSet(new long[]{0x0000000000010000L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__2_in_rule__AllDatatypes__Group__1368 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_14_in_rule__AllDatatypes__Group__1__Impl396 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__2__Impl_in_rule__AllDatatypes__Group__2427 = new BitSet(new long[]{0x0000000000020000L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__3_in_rule__AllDatatypes__Group__2430 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group_2__0_in_rule__AllDatatypes__Group__2__Impl457 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__3__Impl_in_rule__AllDatatypes__Group__3487 = new BitSet(new long[]{0x0000000000008000L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__4_in_rule__AllDatatypes__Group__3490 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group_3__0_in_rule__AllDatatypes__Group__3__Impl517 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group__4__Impl_in_rule__AllDatatypes__Group__4547 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_15_in_rule__AllDatatypes__Group__4__Impl575 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group_2__0__Impl_in_rule__AllDatatypes__Group_2__0616 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group_2__1_in_rule__AllDatatypes__Group_2__0619 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_16_in_rule__AllDatatypes__Group_2__0__Impl647 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group_2__1__Impl_in_rule__AllDatatypes__Group_2__1678 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__ELatLongAssignment_2_1_in_rule__AllDatatypes__Group_2__1__Impl705 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group_3__0__Impl_in_rule__AllDatatypes__Group_3__0739 = new BitSet(new long[]{0x0000000000001800L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group_3__1_in_rule__AllDatatypes__Group_3__0742 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_17_in_rule__AllDatatypes__Group_3__0__Impl770 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__Group_3__1__Impl_in_rule__AllDatatypes__Group_3__1801 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__AllDatatypes__EMoneyAssignment_3_1_in_rule__AllDatatypes__Group_3__1__Impl828 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__0__Impl_in_rule__ELatLong__Group__0862 = new BitSet(new long[]{0x0000000000040000L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__1_in_rule__ELatLong__Group__0865 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_RULE_INT_in_rule__ELatLong__Group__0__Impl892 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__1__Impl_in_rule__ELatLong__Group__1921 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__2_in_rule__ELatLong__Group__1924 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_18_in_rule__ELatLong__Group__1__Impl952 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__2__Impl_in_rule__ELatLong__Group__2983 = new BitSet(new long[]{0x0000000000080000L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__3_in_rule__ELatLong__Group__2986 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_RULE_INT_in_rule__ELatLong__Group__2__Impl1013 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__3__Impl_in_rule__ELatLong__Group__31042 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__4_in_rule__ELatLong__Group__31045 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_19_in_rule__ELatLong__Group__3__Impl1073 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__4__Impl_in_rule__ELatLong__Group__41104 = new BitSet(new long[]{0x0000000000040000L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__5_in_rule__ELatLong__Group__41107 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_RULE_INT_in_rule__ELatLong__Group__4__Impl1134 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__5__Impl_in_rule__ELatLong__Group__51163 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__6_in_rule__ELatLong__Group__51166 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_18_in_rule__ELatLong__Group__5__Impl1194 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__ELatLong__Group__6__Impl_in_rule__ELatLong__Group__61225 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_RULE_INT_in_rule__ELatLong__Group__6__Impl1252 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__EMoney__Group__0__Impl_in_rule__EMoney__Group__01295 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_rule__EMoney__Group__1_in_rule__EMoney__Group__01298 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__EMoney__Alternatives_0_in_rule__EMoney__Group__0__Impl1325 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__EMoney__Group__1__Impl_in_rule__EMoney__Group__11355 = new BitSet(new long[]{0x0000000000040000L});
        public static final BitSet FOLLOW_rule__EMoney__Group__2_in_rule__EMoney__Group__11358 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_RULE_INT_in_rule__EMoney__Group__1__Impl1385 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__EMoney__Group__2__Impl_in_rule__EMoney__Group__21414 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__EMoney__Group_2__0_in_rule__EMoney__Group__2__Impl1441 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__EMoney__Group_2__0__Impl_in_rule__EMoney__Group_2__01477 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_rule__EMoney__Group_2__1_in_rule__EMoney__Group_2__01480 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_18_in_rule__EMoney__Group_2__0__Impl1508 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rule__EMoney__Group_2__1__Impl_in_rule__EMoney__Group_2__11539 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_RULE_INT_in_rule__EMoney__Group_2__1__Impl1566 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleELatLong_in_rule__AllDatatypes__ELatLongAssignment_2_11604 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleEMoney_in_rule__AllDatatypes__EMoneyAssignment_3_11635 = new BitSet(new long[]{0x0000000000000002L});
    }


}