package org.jscience.xtext.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.jscience.xtext.services.JscienceGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalJscienceParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_INT", "RULE_ID", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'AllDatatypes'", "'{'", "'eLatLong'", "'eMoney'", "'}'", "'.'", "','", "'\\u20AC'", "'$'"
    };
    public static final int RULE_ID=5;
    public static final int RULE_ANY_OTHER=10;
    public static final int EOF=-1;
    public static final int RULE_SL_COMMENT=8;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__19=19;
    public static final int RULE_STRING=6;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int RULE_INT=4;
    public static final int RULE_WS=9;

    // delegates
    // delegators


        public InternalJscienceParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalJscienceParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalJscienceParser.tokenNames; }
    public String getGrammarFileName() { return "../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g"; }



     	private JscienceGrammarAccess grammarAccess;
     	
        public InternalJscienceParser(TokenStream input, JscienceGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "AllDatatypes";	
       	}
       	
       	@Override
       	protected JscienceGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleAllDatatypes"
    // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:67:1: entryRuleAllDatatypes returns [EObject current=null] : iv_ruleAllDatatypes= ruleAllDatatypes EOF ;
    public final EObject entryRuleAllDatatypes() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAllDatatypes = null;


        try {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:68:2: (iv_ruleAllDatatypes= ruleAllDatatypes EOF )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:69:2: iv_ruleAllDatatypes= ruleAllDatatypes EOF
            {
             newCompositeNode(grammarAccess.getAllDatatypesRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleAllDatatypes_in_entryRuleAllDatatypes75);
            iv_ruleAllDatatypes=ruleAllDatatypes();

            state._fsp--;

             current =iv_ruleAllDatatypes; 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleAllDatatypes85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAllDatatypes"


    // $ANTLR start "ruleAllDatatypes"
    // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:76:1: ruleAllDatatypes returns [EObject current=null] : (otherlv_0= 'AllDatatypes' otherlv_1= '{' (otherlv_2= 'eLatLong' ( (lv_eLatLong_3_0= ruleELatLong ) ) ) (otherlv_4= 'eMoney' ( (lv_eMoney_5_0= ruleEMoney ) ) ) otherlv_6= '}' ) ;
    public final EObject ruleAllDatatypes() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        AntlrDatatypeRuleToken lv_eLatLong_3_0 = null;

        AntlrDatatypeRuleToken lv_eMoney_5_0 = null;


         enterRule(); 
            
        try {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:79:28: ( (otherlv_0= 'AllDatatypes' otherlv_1= '{' (otherlv_2= 'eLatLong' ( (lv_eLatLong_3_0= ruleELatLong ) ) ) (otherlv_4= 'eMoney' ( (lv_eMoney_5_0= ruleEMoney ) ) ) otherlv_6= '}' ) )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:80:1: (otherlv_0= 'AllDatatypes' otherlv_1= '{' (otherlv_2= 'eLatLong' ( (lv_eLatLong_3_0= ruleELatLong ) ) ) (otherlv_4= 'eMoney' ( (lv_eMoney_5_0= ruleEMoney ) ) ) otherlv_6= '}' )
            {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:80:1: (otherlv_0= 'AllDatatypes' otherlv_1= '{' (otherlv_2= 'eLatLong' ( (lv_eLatLong_3_0= ruleELatLong ) ) ) (otherlv_4= 'eMoney' ( (lv_eMoney_5_0= ruleEMoney ) ) ) otherlv_6= '}' )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:80:3: otherlv_0= 'AllDatatypes' otherlv_1= '{' (otherlv_2= 'eLatLong' ( (lv_eLatLong_3_0= ruleELatLong ) ) ) (otherlv_4= 'eMoney' ( (lv_eMoney_5_0= ruleEMoney ) ) ) otherlv_6= '}'
            {
            otherlv_0=(Token)match(input,11,FollowSets000.FOLLOW_11_in_ruleAllDatatypes122); 

                	newLeafNode(otherlv_0, grammarAccess.getAllDatatypesAccess().getAllDatatypesKeyword_0());
                
            otherlv_1=(Token)match(input,12,FollowSets000.FOLLOW_12_in_ruleAllDatatypes134); 

                	newLeafNode(otherlv_1, grammarAccess.getAllDatatypesAccess().getLeftCurlyBracketKeyword_1());
                
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:88:1: (otherlv_2= 'eLatLong' ( (lv_eLatLong_3_0= ruleELatLong ) ) )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:88:3: otherlv_2= 'eLatLong' ( (lv_eLatLong_3_0= ruleELatLong ) )
            {
            otherlv_2=(Token)match(input,13,FollowSets000.FOLLOW_13_in_ruleAllDatatypes147); 

                	newLeafNode(otherlv_2, grammarAccess.getAllDatatypesAccess().getELatLongKeyword_2_0());
                
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:92:1: ( (lv_eLatLong_3_0= ruleELatLong ) )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:93:1: (lv_eLatLong_3_0= ruleELatLong )
            {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:93:1: (lv_eLatLong_3_0= ruleELatLong )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:94:3: lv_eLatLong_3_0= ruleELatLong
            {
             
            	        newCompositeNode(grammarAccess.getAllDatatypesAccess().getELatLongELatLongParserRuleCall_2_1_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleELatLong_in_ruleAllDatatypes168);
            lv_eLatLong_3_0=ruleELatLong();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getAllDatatypesRule());
            	        }
                   		set(
                   			current, 
                   			"eLatLong",
                    		lv_eLatLong_3_0, 
                    		"ELatLong");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }

            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:110:3: (otherlv_4= 'eMoney' ( (lv_eMoney_5_0= ruleEMoney ) ) )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:110:5: otherlv_4= 'eMoney' ( (lv_eMoney_5_0= ruleEMoney ) )
            {
            otherlv_4=(Token)match(input,14,FollowSets000.FOLLOW_14_in_ruleAllDatatypes182); 

                	newLeafNode(otherlv_4, grammarAccess.getAllDatatypesAccess().getEMoneyKeyword_3_0());
                
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:114:1: ( (lv_eMoney_5_0= ruleEMoney ) )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:115:1: (lv_eMoney_5_0= ruleEMoney )
            {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:115:1: (lv_eMoney_5_0= ruleEMoney )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:116:3: lv_eMoney_5_0= ruleEMoney
            {
             
            	        newCompositeNode(grammarAccess.getAllDatatypesAccess().getEMoneyEMoneyParserRuleCall_3_1_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleEMoney_in_ruleAllDatatypes203);
            lv_eMoney_5_0=ruleEMoney();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getAllDatatypesRule());
            	        }
                   		set(
                   			current, 
                   			"eMoney",
                    		lv_eMoney_5_0, 
                    		"EMoney");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }

            otherlv_6=(Token)match(input,15,FollowSets000.FOLLOW_15_in_ruleAllDatatypes216); 

                	newLeafNode(otherlv_6, grammarAccess.getAllDatatypesAccess().getRightCurlyBracketKeyword_4());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAllDatatypes"


    // $ANTLR start "entryRuleELatLong"
    // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:144:1: entryRuleELatLong returns [String current=null] : iv_ruleELatLong= ruleELatLong EOF ;
    public final String entryRuleELatLong() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleELatLong = null;


        try {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:145:2: (iv_ruleELatLong= ruleELatLong EOF )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:146:2: iv_ruleELatLong= ruleELatLong EOF
            {
             newCompositeNode(grammarAccess.getELatLongRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleELatLong_in_entryRuleELatLong253);
            iv_ruleELatLong=ruleELatLong();

            state._fsp--;

             current =iv_ruleELatLong.getText(); 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleELatLong264); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleELatLong"


    // $ANTLR start "ruleELatLong"
    // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:153:1: ruleELatLong returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= ',' this_INT_4= RULE_INT kw= '.' this_INT_6= RULE_INT ) ;
    public final AntlrDatatypeRuleToken ruleELatLong() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_INT_0=null;
        Token kw=null;
        Token this_INT_2=null;
        Token this_INT_4=null;
        Token this_INT_6=null;

         enterRule(); 
            
        try {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:156:28: ( (this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= ',' this_INT_4= RULE_INT kw= '.' this_INT_6= RULE_INT ) )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:157:1: (this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= ',' this_INT_4= RULE_INT kw= '.' this_INT_6= RULE_INT )
            {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:157:1: (this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= ',' this_INT_4= RULE_INT kw= '.' this_INT_6= RULE_INT )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:157:6: this_INT_0= RULE_INT kw= '.' this_INT_2= RULE_INT kw= ',' this_INT_4= RULE_INT kw= '.' this_INT_6= RULE_INT
            {
            this_INT_0=(Token)match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_ruleELatLong304); 

            		current.merge(this_INT_0);
                
             
                newLeafNode(this_INT_0, grammarAccess.getELatLongAccess().getINTTerminalRuleCall_0()); 
                
            kw=(Token)match(input,16,FollowSets000.FOLLOW_16_in_ruleELatLong322); 

                    current.merge(kw);
                    newLeafNode(kw, grammarAccess.getELatLongAccess().getFullStopKeyword_1()); 
                
            this_INT_2=(Token)match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_ruleELatLong337); 

            		current.merge(this_INT_2);
                
             
                newLeafNode(this_INT_2, grammarAccess.getELatLongAccess().getINTTerminalRuleCall_2()); 
                
            kw=(Token)match(input,17,FollowSets000.FOLLOW_17_in_ruleELatLong355); 

                    current.merge(kw);
                    newLeafNode(kw, grammarAccess.getELatLongAccess().getCommaKeyword_3()); 
                
            this_INT_4=(Token)match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_ruleELatLong370); 

            		current.merge(this_INT_4);
                
             
                newLeafNode(this_INT_4, grammarAccess.getELatLongAccess().getINTTerminalRuleCall_4()); 
                
            kw=(Token)match(input,16,FollowSets000.FOLLOW_16_in_ruleELatLong388); 

                    current.merge(kw);
                    newLeafNode(kw, grammarAccess.getELatLongAccess().getFullStopKeyword_5()); 
                
            this_INT_6=(Token)match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_ruleELatLong403); 

            		current.merge(this_INT_6);
                
             
                newLeafNode(this_INT_6, grammarAccess.getELatLongAccess().getINTTerminalRuleCall_6()); 
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleELatLong"


    // $ANTLR start "entryRuleEMoney"
    // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:211:1: entryRuleEMoney returns [String current=null] : iv_ruleEMoney= ruleEMoney EOF ;
    public final String entryRuleEMoney() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleEMoney = null;


        try {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:212:2: (iv_ruleEMoney= ruleEMoney EOF )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:213:2: iv_ruleEMoney= ruleEMoney EOF
            {
             newCompositeNode(grammarAccess.getEMoneyRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleEMoney_in_entryRuleEMoney449);
            iv_ruleEMoney=ruleEMoney();

            state._fsp--;

             current =iv_ruleEMoney.getText(); 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleEMoney460); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEMoney"


    // $ANTLR start "ruleEMoney"
    // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:220:1: ruleEMoney returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : ( (kw= '\\u20AC' | kw= '$' ) this_INT_2= RULE_INT (kw= '.' this_INT_4= RULE_INT ) ) ;
    public final AntlrDatatypeRuleToken ruleEMoney() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        Token this_INT_2=null;
        Token this_INT_4=null;

         enterRule(); 
            
        try {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:223:28: ( ( (kw= '\\u20AC' | kw= '$' ) this_INT_2= RULE_INT (kw= '.' this_INT_4= RULE_INT ) ) )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:224:1: ( (kw= '\\u20AC' | kw= '$' ) this_INT_2= RULE_INT (kw= '.' this_INT_4= RULE_INT ) )
            {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:224:1: ( (kw= '\\u20AC' | kw= '$' ) this_INT_2= RULE_INT (kw= '.' this_INT_4= RULE_INT ) )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:224:2: (kw= '\\u20AC' | kw= '$' ) this_INT_2= RULE_INT (kw= '.' this_INT_4= RULE_INT )
            {
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:224:2: (kw= '\\u20AC' | kw= '$' )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==18) ) {
                alt1=1;
            }
            else if ( (LA1_0==19) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:225:2: kw= '\\u20AC'
                    {
                    kw=(Token)match(input,18,FollowSets000.FOLLOW_18_in_ruleEMoney499); 

                            current.merge(kw);
                            newLeafNode(kw, grammarAccess.getEMoneyAccess().getEuroSignKeyword_0_0()); 
                        

                    }
                    break;
                case 2 :
                    // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:232:2: kw= '$'
                    {
                    kw=(Token)match(input,19,FollowSets000.FOLLOW_19_in_ruleEMoney518); 

                            current.merge(kw);
                            newLeafNode(kw, grammarAccess.getEMoneyAccess().getDollarSignKeyword_0_1()); 
                        

                    }
                    break;

            }

            this_INT_2=(Token)match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_ruleEMoney534); 

            		current.merge(this_INT_2);
                
             
                newLeafNode(this_INT_2, grammarAccess.getEMoneyAccess().getINTTerminalRuleCall_1()); 
                
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:244:1: (kw= '.' this_INT_4= RULE_INT )
            // ../org.jscience.xtext/src-gen/org/jscience/xtext/parser/antlr/internal/InternalJscience.g:245:2: kw= '.' this_INT_4= RULE_INT
            {
            kw=(Token)match(input,16,FollowSets000.FOLLOW_16_in_ruleEMoney553); 

                    current.merge(kw);
                    newLeafNode(kw, grammarAccess.getEMoneyAccess().getFullStopKeyword_2_0()); 
                
            this_INT_4=(Token)match(input,RULE_INT,FollowSets000.FOLLOW_RULE_INT_in_ruleEMoney568); 

            		current.merge(this_INT_4);
                
             
                newLeafNode(this_INT_4, grammarAccess.getEMoneyAccess().getINTTerminalRuleCall_2_1()); 
                

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEMoney"

    // Delegated rules


 

    
    private static class FollowSets000 {
        public static final BitSet FOLLOW_ruleAllDatatypes_in_entryRuleAllDatatypes75 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleAllDatatypes85 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_11_in_ruleAllDatatypes122 = new BitSet(new long[]{0x0000000000001000L});
        public static final BitSet FOLLOW_12_in_ruleAllDatatypes134 = new BitSet(new long[]{0x0000000000002000L});
        public static final BitSet FOLLOW_13_in_ruleAllDatatypes147 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_ruleELatLong_in_ruleAllDatatypes168 = new BitSet(new long[]{0x0000000000004000L});
        public static final BitSet FOLLOW_14_in_ruleAllDatatypes182 = new BitSet(new long[]{0x00000000000C0000L});
        public static final BitSet FOLLOW_ruleEMoney_in_ruleAllDatatypes203 = new BitSet(new long[]{0x0000000000008000L});
        public static final BitSet FOLLOW_15_in_ruleAllDatatypes216 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleELatLong_in_entryRuleELatLong253 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleELatLong264 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_RULE_INT_in_ruleELatLong304 = new BitSet(new long[]{0x0000000000010000L});
        public static final BitSet FOLLOW_16_in_ruleELatLong322 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_RULE_INT_in_ruleELatLong337 = new BitSet(new long[]{0x0000000000020000L});
        public static final BitSet FOLLOW_17_in_ruleELatLong355 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_RULE_INT_in_ruleELatLong370 = new BitSet(new long[]{0x0000000000010000L});
        public static final BitSet FOLLOW_16_in_ruleELatLong388 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_RULE_INT_in_ruleELatLong403 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleEMoney_in_entryRuleEMoney449 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleEMoney460 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_18_in_ruleEMoney499 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_19_in_ruleEMoney518 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_RULE_INT_in_ruleEMoney534 = new BitSet(new long[]{0x0000000000010000L});
        public static final BitSet FOLLOW_16_in_ruleEMoney553 = new BitSet(new long[]{0x0000000000000010L});
        public static final BitSet FOLLOW_RULE_INT_in_ruleEMoney568 = new BitSet(new long[]{0x0000000000000002L});
    }


}